/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2021  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.util;

import de.steamwar.bausystem.BauSystem;
import de.steamwar.command.SWCommand;
import de.steamwar.linkage.Linked;
import org.bukkit.entity.Player;

@Linked
public class SpeedCommand extends SWCommand {

    public SpeedCommand() {
        super("speed");
    }

    @Register(help = true)
    public void genericHelp(Player p, String... args) {
        BauSystem.MESSAGE.sendPrefixless("SPEED_HELP", p);
        BauSystem.MESSAGE.send("SPEED_CURRENT", p, (p.getFlySpeed() * 10F));
    }

    @Register
    public void speedCommand(Player p, float speed) {
        if (speed < -10F) {
            BauSystem.MESSAGE.send("SPEED_TOO_SMALL", p, speed);
        } else if (speed > 10F) {
            BauSystem.MESSAGE.send("SPEED_TOO_HIGH", p, speed);
        } else {
            speed = speed / 10F;
            p.setFlySpeed(speed);
            p.setWalkSpeed(Math.min(speed + 0.1F, 1F));
            BauSystem.MESSAGE.send("SPEED_CURRENT", p, (p.getFlySpeed() * 10F));
        }
    }

    @Register({"default"})
    public void speedCommand(Player p) {
        speedCommand(p, 1);
    }
}